"use strict";

var tempEpsText = "";
var epsHeader = "";
var satir = 1;
var rowgap = 300;
var yuk = 250;
var totalHeight = 1260;
var vShift = 0;
var hShift = 0;
var marj = 0;
var WaveformGenerator = function(t, e) {
    function a() {
        return "a" + Math.floor(65536 * (1 + Math.random())).toString(16).substring(1) + "b" + Math.floor(65536 * (1 + Math.random())).toString(16).substring(1)
    }

    function r(t, e) {

        var a = d.barWidth;
        0 !== d.barGap && (a *= Math.abs(1 - d.barGap));
        var r, o = t + a / 2;
        switch (d.barAlign) {
            case "top":
                r = 0;
                break;
            case "center":
                r = d.waveformHeight / 2 - e / 2;
                break;
            case "bottom":
                r = d.waveformHeight - e
        }
        if ("png" === d.drawMode) {
            o = Math.floor(o - 1), r = Math.floor(r - 1);
            var n = v.getContext("2d");
            if (o > 2068) {
                hShift = 2069;
                vShift = yuk + rowgap
            }
            if (o > 4137) {
                hShift = 4138;
                vShift = (yuk + rowgap) * 2
            }
            if (o > 6204) {
                hShift = 6205;
                vShift = (yuk + rowgap) * 3
            }
            if (e < yuk * 0.8) {
                e = e * 0.5
                tempEpsText += "newpath\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + totalHeight - yuk - vShift - marj)) + " moveto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + totalHeight - yuk - vShift - marj)) + " lineto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + (e * 2) + totalHeight - yuk - vShift - marj)) + " lineto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + (e * 2) + totalHeight - yuk - vShift - marj)) + " lineto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + totalHeight - yuk - vShift - marj)) + " lineto\n";
            } else {
                tempEpsText += "newpath\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + totalHeight - yuk - vShift - marj)) + " moveto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + totalHeight - yuk - vShift - marj)) + " lineto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + e + totalHeight - yuk - vShift - marj)) + " lineto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + e + totalHeight - yuk - vShift - marj)) + " lineto\n";
                tempEpsText += Number(o - hShift) + " " + Math.floor(Number(r + totalHeight - yuk - vShift - marj)) + " lineto\n";
            }
            tempEpsText += "1.8 setlinewidth\n";
            tempEpsText += "gsave 0 0 0 setrgbcolor fill grestore\n"
            tempEpsText += "closepath\n";
            tempEpsText += "stroke\n";
        } else if ("svg" === d.drawMode) {
            var i = document.createElement("path");
            i.setAttribute("d", "M" + o + " " + r + " L" + o + " " + r + " L" + o + " " + (r + e) + " L" + o + " " + (r + e) + " L" + o + " " + r + " Z"), i.className = l.id, l.appendChild(i)
        }
    }

    function o(t, e, a) {
        for (var r = 0, o = t, n = t + e - 1; n >= t ? n >= o : o >= n; n >= t ? o++ : o--) r += Math.pow(a[o], 2);
        return Math.sqrt(r / a.length)
    }

    function n(t) {
        return new Promise(function(e, a) {
            t = t.getChannelData(0);
            var rat = Math.round(t.length / 1543);
            if (rat > 8000) {
                rat = 8000;
                marj = 0
            } else if (rat < 1000) {
                rat = 2068;
                yuk = 400
            }
            if (rat > 2068) {
                marj = 0;
                satir = 2;
                yuk = 350;
                rowgap = 186;
                totalHeight = satir * yuk + ((satir - 1) * rowgap)
            }
            if (rat > 4137) {
                marj = 0;
                satir = 3;
                yuk = 300;
                rowgap = 180;
                totalHeight = satir * yuk + ((satir - 1) * rowgap)
            }
            if (rat > 6204) {
                marj = 0;
                satir = 4;
                yuk = 250;
                rowgap = 86;
                totalHeight = satir * yuk + ((satir - 1) * rowgap)
            }
            if (rat == 2068) {
                marj = 0;
                yuk = 400;
                totalHeight = yuk
            }

            if (pStyle == "style3") {
                rat = 2068;
                yuk = 600;
                totalHeight = yuk;
                rowgap = 0
            }
            d.waveformHeight = yuk;
            epsHeader = "" + "%!PS-Adobe-3.0 EPSF-3.0\n" + "%%BoundingBox: 0 0 " + 2068 + " " + totalHeight + "\n";

            for (var n = rat, i = Math.floor(t.length / n), h = [], s = [], l = 0; n > l; l += d.barWidth) {
                var u = {};


                u.position = l, u.height = o(l * i, i, t), s.push(u.height), h.push(u)

            }
            for (var v = d.waveformHeight / Math.max.apply(null, s), l = 0; l < h.length; l++) {
                var c = h[l],
                    f = c.height,
                    g = c.position;
                f *= v, r(g, f)
            }
            e()
        })
    }

    function i(t, e) {
        try {
            return new Promise(function(r, o) {
                s.decodeAudioData(t, function(t) {
                    if (!t) return void o(new Error("Could not decode audio data"));
                    var i = a();
                    l = document.createElement("svg"), l.id = i, l.setAttribute("xmlns", "http://www.w3.org/2000/svg"), l.setAttribute("version", "1.1"), l.setAttributeNS(null, "viewBox", "0 0 " + d.waveformWidth + " " + d.waveformHeight), u = document.createElement("style"), u.setAttribute("type", "text/css"), u.appendChild(document.createTextNode("<![CDATA[path." + l.id + "{stroke:" + d.waveformColor + ";stroke-width:" + (0 !== d.barGap ? d.barWidth * Math.abs(1 - d.barGap) : d.barWidth) + "}]]>")), l.appendChild(u), v = document.createElement("canvas"), v.id = i, v.width = d.waveformWidth, v.height = d.waveformHeight;
                    var s = v.getContext("2d");
                    s.clearRect(0, 0, v.width, v.height), n(t).then(function() {
                        if ("svg" === d.drawMode) {
                            var t = "data:image/svg+xml;base64," + btoa('<?xml version="1.0" standalone="no"?><!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">' + l.outerHTML);
                            r(t)
                        } else {
                            "png" === d.drawMode && r(v.toDataURL())
                        }
                    })
                })
            })
        } catch (e) {
            alert(e)
        }
    }
    var d = {
            waveformWidth: 8000,
            waveformHeight: 250,
            waveformColor: "#bada55",
            barAlign: "center",
            barWidth: 1,
            barGap: 0,
            drawMode: "png"
        },
        s = new AudioContext || new WebkitAudioContext,
        l = null,
        u = null,
        v = null;
    return i
}();
//# sourceMappingURL=WaveformGenerator.js.map