﻿G = {

  /* INFO ======================================= */
  COMPANY: "Design Rocket",
  CONTACT_INFO: "erengoksel@gmail.com",
  PRODUCT_NAME: "Lovely Chaos",
  PRODUCT_ID: "com.designrocket.LovelyChaos",
  PRODUCT_VERSION: "0.1.0",
  PRODUCT_ALIAS: "DRLC",
  MIN_VERSION: void 0,
  MAX_VERSION: void 0,

  HTML_PANEL: "ASSETS/HTML",
  SCRIPT: "ASSETS/SCRIPT",
  SYSTEM_INSTALL: false,

  INSTALLER_VERSION: "0.1.1",
  IGNORE: void 0,

  CURRENT_PATH: File($.fileName).path,
  CURRENT_PS_VERSION: app.version.split('.')[0]
};

var filename = new File($.fileName);
var myJSXPath = filename.parent;


//var actionsPath = app.path + "/" + localize("$$$/ScriptingSupport/InstalledActions=Presets/Actions");   
//var scriptsPath = app.path + "/" + localize("$$$/ScriptingSupport/InstalledScripts=Presets/Scripts");
//var shapesPath = app.path + "/" + localize("$$$/ScriptingSupport/InstalledCustom Shapes=Presets/Custom Shapes");
var panelsPath = "" + (G.SYSTEM_INSTALL ? Folder.commonFiles : Folder.userData) + "/Adobe/" + (G.CURRENT_PS_VERSION === '14' ? 'CEPServiceManager4' : 'CEP') + "/extensions/";


function copyFiles(){
copyFolder(new Folder(myJSXPath+"/"+G.PRODUCT_ALIAS+"/"+G.PRODUCT_ID), new Folder(panelsPath+G.PRODUCT_ID));  
}
  
function copyFolder(sourceFolder, destinationFolder) {  
    var sourceChildrenArr = sourceFolder.getFiles();  
    for (var i = 0; i < sourceChildrenArr.length; i++) {  
        var sourceChild = sourceChildrenArr[i];  
        var destinationChildStr = destinationFolder.fsName + "/" + sourceChild.name;  
        
        if (sourceChild instanceof File) {  
            copyFile(sourceChild, new File(destinationChildStr)); 
        }  
        else {  
            copyFolder(sourceChild, new Folder(destinationChildStr));  
        }  
    }  
} 
  
  
function copyFile(sourceFile, destinationFile) {  
    createFolder(destinationFile.parent);  
    sourceFile.copy(destinationFile);  
} 

function createFolder(folder) {  
    if (folder.parent !== null && !folder.parent.exists) {  
        createFolder(folder.parent);  
    }  
    folder.create();  
} 


//copyFiles();
var box = new Window('dialog', "Lovely Chaos");  
box.panel3 = box.add('panel', undefined, undefined);  
box.panel3.group = box.panel3.add('group', undefined );  
box.panel3.group.preferredSize=[400, 40];
box.panel3.group.orientation='row';  
box.panel3.group.text0 = box.panel3.group.add('statictext', undefined,  "This will install Lovely Chaos for Adobe Illustrator", {multiline:true}); 
box.panel3.group.text0.preferredSize = [350,40];
box.panel2 = box.add('panel', undefined, undefined );  
box.panel2.group = box.panel2.add('group', undefined );  
box.panel2.group.preferredSize=[400, -1];
box.panel2.group.orientation='row';  
box.panel2.group.goBtn = box.panel2.group.add('button',undefined, "Continue", {name:'close'});  
box.panel2.group.closeBtn = box.panel2.group.add('button',undefined, "Cancel", {name:'Somewhat'});  
box.panel2.group.goBtn.alignment = ['right','top'];
box.panel2.group.closeBtn.alignment = ['right','top'];
box.panel2.group.closeBtn.onClick = function(){  
box.close();  
} 
box.panel2.group.goBtn.onClick = function(){  
box.panel3.group.text0.text = 'Installing Lovely Chaos';
box.panel2.group.closeBtn.visible = false;
box.panel2.group.goBtn.visible = false;
box.update();
copyFiles();
updateDialog();

}


function updateDialog(){
    box.panel2.group.closeBtn.visible = true;
    box.panel2.group.closeBtn.text = 'Close';
    
    box.panel3.group.text0.text = 'Extension Installed Succesfully. Please restart Illustrator and navigate to Window>Extensions to launch Lovely Chaos';
}


box.show();